/*
 *  funciones.c
 *  bdd_101
 *
 *  Created by coti on 16/11/09.
 *  Copyright 2009 Tests by Coti. All rights reserved.
 *
 */

#include "funciones.h"

void listado(GlobalesRef g)
{
	int i;
	char * formato = "%4d %65s %4d %6.2f\n";
	printf("\n\nListado\n\n");
	printf("%4s %65s %4s %s\n", "Nº", "Nombre", "Edad", "Talla");
	for (i=0; i<g->numRegistros; i++) {
		if (g->p[i].edad !=0)
			printf(formato,i, g->p[i].nombre, g->p[i].edad, g->p[i].talla);
	}
	printf("\n");
}
void iniciacion(GlobalesRef g)
{
	int i;
	long numBytes;
	strcpy(g->ruta_archivo_informes,"informes.txt");
	strcpy(g->ruta_archivo_datos, "datos.bin");
	Registro zero = {
		"",0,0.0
	};
	FILERef fp = fopen(g->ruta_archivo_datos, "r");
	if (NULL == fp) { 
			// No existe el archivo de datos
		g->numRegistros = 100;
		g->p = malloc(g->numRegistros*sizeof(Registro));
		for (i=0; i<g->numRegistros; i++) {
			g->p[i] = zero;
		}
	} else {
			// Existe un archivo de datos
		fseek(fp, 0, SEEK_END);
		numBytes = ftell(fp);
		g->numRegistros = numBytes/sizeof(Registro);
		if (g->p)
			free(g->p);
		g->p = malloc(numBytes);
		rewind(fp);
		fread(g->p, sizeof(Registro), g->numRegistros, fp);
		fclose(fp);
	}
	
}
void conclusion(GlobalesRef g){
	FILERef fp = fopen(g->ruta_archivo_datos, "w");
	if (NULL == fp) {
		printf("\n\nNo fue posible guardar la información.\n\n");
		return;
	}
	fwrite(g->p, sizeof(Registro), g->numRegistros, fp);
	fclose(fp);
}
void altas(GlobalesRef g)
{
	int num_registro_vacio = -1;
	int i;
	for (i=0; i<g->numRegistros; i++) {
		if (0 == g->p[i].edad) {
			num_registro_vacio = i;
			break;
		}
	}
	if (-1 == num_registro_vacio) {
		printf("\n\nImposible dar alta: base de datos llena\n\n");
	}
	else {
		rellenar_registro(g->p+num_registro_vacio);
	}
	
}
void bajas(GlobalesRef g)
{
	int num_registro_eliminado = -1;
	listado(g);
	do{
		num_registro_eliminado = pedirInt(
										  "Deme el número del registro eliminado",
										  0,
										  g->numRegistros);
	} while(0 == g->p[num_registro_eliminado].edad);
	g->p[num_registro_eliminado].edad = 0;
}
void informes(GlobalesRef g)
{
	char name[64];
	int valor_edad;
	float valor_talla;
	char c;
	int i;
	FILERef fp;
	fp = fopen(g->ruta_archivo_informes, "w");
	if (NULL == fp) {
		printf("\n\nNo fue posible abrir el archivo de informes.\n\n");
		return;
	}
	do {
		printf("\n\nInforme por (1) Nombre (2) Edad (3) Talla: [ESC] ");
		printf("\n\n");
		switch (c=getch()) {
			case '1':
				strcpy(name,pedir("Nombre buscado: "));
				printf("\n%30s %4s %6s\n", "Nombre", "Edad", "Talla");
				for (i=0; i<g->numRegistros; i++) {
					if (strcmp(name, g->p[i].nombre) == 0) {
						escribir_registro_archivo(stdout, g->p+i);
						escribir_registro_archivo(fp,g->p+i);
					}
				}
				break;
			case '2':
				valor_edad = pedirInt("Edad buscada: ", 18, 100);
				printf("\n%30s %4s %6s\n", "Nombre", "Edad", "Talla");
				for (i=0; i<g->numRegistros; i++) {
					if (valor_edad == g->p[i].edad) {
						escribir_registro_archivo(stdout, g->p+i);
						escribir_registro_archivo(fp, g->p+i);
					}
				}
				break;
			case '3':
				valor_talla = pedirFloat("Talla buscada: ", 100, 250);
				printf("\n%30s %4s %6s\n", "Nombre", "Edad", "Talla");
				for (i=0; i<g->numRegistros; i++) {
					if (valor_talla == g->p[i].talla) {
						escribir_registro_archivo(stdout, g->p+i);
						escribir_registro_archivo(fp, g->p+i);
					}
				}
				break;
			case '\x1b':
				break;
			default:
				printf("\n\nOpción incorrecta\n\n");
				break;
		}
	} while (c!='\x1b');
	fclose(fp);
	printf("\n\n");
}
void modificaciones(GlobalesRef g)
{
	int num_registro;
	listado(g);
	num_registro = pedirInt("Registro modificado: ", 0, g->numRegistros);
	printf("\n\nContenido actual:\n\n");
	escribir_registro_archivo(stdout, g->p+num_registro);
	printf("\n\nNuevo contenido:");
	rellenar_registro(g->p+num_registro);
}

void rellenar_registro(RegistroRef p)
{
	printf("\n\n");
	p->edad = pedirInt("Escriba la edad: ", 18, 100);
	p->talla = pedirFloat("Escriba la talla (cm): ", 100.0, 250.0);
	do {
		strcpy(p->nombre,pedir("Escriba su nombre: "));
	} while(strlen(p->nombre) == 0);
}

void escribir_registro_archivo(FILE * fp, Registro * p)
{
	fprintf(fp, "%30s %4d %6.2f\n",p->nombre, p->edad, p->talla);
}

