/*
 *  funciones.c
 *  bdd_101
 *
 *  Created by coti on 16/11/09.
 *  Copyright 2009 Tests by Coti. All rights reserved.
 *
 */

#include "funciones.h"

void listado(GlobalesRef g)
{
	int i;
	char * formato = "%65s %4d %6.2f\n";
	printf("\n\nListado\n\n");
	for (i=0; i<g->numRegistros; i++) {
		if (g->p[i]->edad !=0)
			printf(formato, g->p[i]->nombre, g->p[i]->edad, g->p[i]->talla);
	}
	printf("\n");
}

void iniciacion(GlobalesRef g)
{
	int i;
	Registro cero = {"", 0, 0.0};
	strcpy(g->ruta_archivo_datos,"datos.bin");
	strcpy(g->ruta_archivo_informes, "informes.txt");
	FILERef fp = fopen(g->ruta_archivo_datos, "r");
	int numBytes;
	if (NULL == fp) { // Si no hay un archivo de datos previo
		g->numRegistros = 100;
			// Se reserva espacio para un bloque de punteros
		g->p = malloc(g->numRegistros*sizeof(RegistroRef));
			// Se almacena en cada puntero del bloque la dirección de un registro
		for (i=0; i<g->numRegistros; i++) {
			g->p[i] = malloc(sizeof(Registro));
			*g->p[i] = cero;
		}
		printf("\n\nSe ha creado una base de datos nueva.\n\n");
	} else { // Si hay un archivo de datos previo
		fseek(fp, 0, SEEK_END);
		numBytes = ftell(fp);
		g->numRegistros = numBytes/sizeof(Registro);
			// Se crea un bloque de punteros con tantos punteros
			// como registros hay en el archivo.
		g->p = malloc(g->numRegistros*sizeof(RegistroRef));
		rewind(fp);// Esencial!!
		for (i=0; i<g->numRegistros; i++) {
			g->p[i] = malloc(sizeof(Registro));
			fread(g->p[i], sizeof(Registro), 1, fp);
		}
		fclose(fp);
		printf("\n\nSe leído el archivo de datos.\n\n");
	}
}

void conclusion(GlobalesRef g){
	int i;
	FILERef fp = fopen(g->ruta_archivo_datos, "w");
	for (i=0; i<g->numRegistros; i++) {
		fwrite(g->p[i], sizeof(Registro), 1, fp);
	}
	fclose(fp);
}
void altas(GlobalesRef g)
{
	int num_registro_vacio = -1;
	int i;
	for (i=0; i<g->numRegistros; i++) {
		if (0 == g->p[i]->edad) {
			num_registro_vacio = i;
			break;
		}
	}
	if (-1 == num_registro_vacio) {
		printf("\n\nImposible dar alta: base de datos llena\n\n");
	}
	else {
		rellenar_registro(g->p[num_registro_vacio]);
	}
	
}
void bajas(GlobalesRef g)
{
	int num_registro_eliminado = -1;
	listado(g);
	do{
		num_registro_eliminado = pedirInt("Deme el número del registro eliminado", 0, g->numRegistros);
	} while(0 == g->p[num_registro_eliminado]->edad);
	g->p[num_registro_eliminado]->edad = 0;
	g->p[num_registro_eliminado]->talla = 0.0;
	strcpy(g->p[num_registro_eliminado]->nombre, "");
	
}
void informes(GlobalesRef g)
{
	char name[64];
	int valor_edad;
	float valor_talla;
	char c;
	int i;
	FILERef fp = fopen(g->ruta_archivo_informes, "w");
	if (NULL == fp){
		printf("\n\nNo fue posible crear el archivo de informes.\n\n");
		return;
	}
	do {
		printf("\n\nInforme por (1) Nombre (2) Edad (3) Talla: [ESC] ");
		printf("\n\n");
		switch (c=getch()) {
			case '1':
				strcpy(name,pedir("Nombre buscado: "));
				for (i=0; i<g->numRegistros; i++) {
					if (strcmp(name, g->p[i]->nombre) == 0) {
						escribir_registro_archivo(fp, g->p[i]);
						escribir_registro_archivo(stdout, g->p[i]);
					}
				}
				break;
			case '2':
				valor_edad = pedirInt("Edad buscada: ", 18, 100);
				for (i=0; i<g->numRegistros; i++) {
					if (valor_edad == g->p[i]->edad) {
						escribir_registro_archivo(fp, g->p[i]);
						escribir_registro_archivo(stdout, g->p[i]);
					}
				}
				break;
			case '3':
				valor_talla = pedirFloat("Talla buscada: ", 100, 250);
				for (i=0; i<g->numRegistros; i++) {
					if (valor_talla == g->p[i]->talla) {
						escribir_registro_archivo(fp, g->p[i]);
						escribir_registro_archivo(stdout, g->p[i]);
					}
				}
				break;
			case '\x1b':
				printf("\n\n");
				break;
			default:
				printf("\n\nOpción incorrecta\n\n");
				break;
		}
	} while (c!='\x1b');
	fclose(fp);
}

void modificaciones(GlobalesRef g)
{
	int num_registro;
	Registro temp;
	int opcion;
	listado(g);
	num_registro = pedirInt("Registro modificado: ", 0, g->numRegistros);
	escribir_registro_archivo(stdout, g->p[num_registro]);
	rellenar_registro(&temp);
	opcion = pedirInt("¿Desea guardar los cambios (0/1)?", 0, 1 );
	if (1 == opcion) {
		*g->p[num_registro] = temp;
	}// sino, no hagas nada
}

void rellenar_registro(RegistroRef p)
{
	printf("\n\n");
	p->edad = pedirInt("Escriba la edad: ", 18, 100);
	p->talla = pedirFloat("Escriba la talla (cm): ", 100.0, 250.0);
	do {
		strcpy(p->nombre,pedir("Escriba su nombre: "));
	} while(strlen(p->nombre) == 0);
	printf("\n\n");
}

void escribir_registro_archivo(FILERef fp, RegistroRef p)
{
	fprintf(fp, "%30s %5d %6.2f\n",p->nombre, p->edad, p->talla);
}

