/*
 *  funciones.c
 *  Listas
 *
 *  Created by coti on 11/12/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "funciones.h"

void iniciacion(GlobalRef p){
	p->ppio = p->fin = NULL;
	strcpy(p->ruta,"datos.bin");
	FILE * fp;
	long numNodos;
	long numBytes;
	int i;
	NodoRef nuevoNodo;
	fp = fopen(p->ruta, "r");
	if (NULL == fp) // No existe el archivo
		{
		p->ppio = NULL;
		p->fin = NULL;
		return;
		}
	fseek(fp, 0, SEEK_END);
	numBytes = ftell(fp);
	numNodos = numBytes/sizeof(Nodo);
	rewind(fp);
	for (i=0; i<numNodos; i++) {
		nuevoNodo = malloc(sizeof(Nodo));
		fread(nuevoNodo, sizeof(Nodo), 1, fp);
		insertarOrdenadoNombreNodoDado(p, nuevoNodo);
	}
	fclose(fp);
}

void conclusion(GlobalRef p){
	FILE * fp = fopen(p->ruta, "w");
	NodoRef temp;
	for (temp = p->ppio; temp != NULL; temp = temp->sig) {
		fwrite(temp, sizeof(Nodo), 1, fp);
	}
	fclose(fp);
		// En realidad, esto sobraría
	vaciar(p);
	p->ppio = p->fin = NULL;
}

void anadirPpio(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	printf("\n\nAñadir un nodo al principio de la lista.\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		temp->sig = p->ppio;
		p->ppio = temp;
	}
	printf("\n\n");
}

void anadirFinal(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	printf("\n\nAñadir un nodo al final de la lista.\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		p->fin->sig = temp;
		p->fin = temp;
	}
	printf("\n\n");
}

void anadirPpioNodoDado(GlobalRef p, NodoRef temp){
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		temp->sig = p->ppio;
		p->ppio = temp;
	}
}

void anadirFinalNodoDado(GlobalRef p, NodoRef temp){
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		p->fin->sig = temp;
		p->fin = temp;
	}
}

NodoRef eliminarPrincipio(GlobalRef p){
	NodoRef temp = p->ppio;
	if (NULL != p->ppio) {
		if (NULL == p->ppio->sig) {
			p->ppio = p->fin = NULL;
		} else {
			p->ppio = p->ppio->sig;
		}
	}
	return temp;
}

NodoRef eliminarFinal(GlobalRef p){
	NodoRef temp = p->fin;
	NodoRef penultimo;
	printf("\n\nExtraer el último nodo de la lista.\n\n");
	if (NULL != p->ppio) {
		if (NULL == p->ppio->sig) {
			p->ppio = p->fin = NULL;
		} else {
			penultimo = p->ppio;
			while (penultimo->sig != p->fin) {
				penultimo = penultimo->sig;
			}
			p->fin = penultimo;
			p->fin->sig =NULL;
		}
	}
	return temp;
}

void insertarOrdenadoNombreNodoDado(GlobalRef p, NodoRef temp){
	NodoRef ant, pos;
	temp->sig = NULL;
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		if (strcmp(temp->nombre, p->ppio->nombre)<=0) {
			anadirPpioNodoDado(p, temp);
		} else {
			if (strcmp(temp->nombre, p->fin->nombre)>=0) {
				anadirFinalNodoDado(p, temp);
			} else { // El nodo debe ocupar una posición intermedia
				ant = p->ppio;
				pos = p->ppio->sig;
				while (!(strcmp(ant->nombre,temp->nombre)<=0 && strcmp(temp->nombre,pos->nombre)<=0)) {
					ant = pos;
					pos = pos->sig;
				}
				temp->sig = pos;
				ant->sig = temp;
			}
		}
	}
}

void insertarOrdenadoNombre(GlobalRef p){
	NodoRef temp = malloc(sizeof(Nodo));
	NodoRef ant, pos;
	printf("\n\nInsertar un nodo (por orden Nombre).\n\n");
	rellenarNodo(temp);temp->sig = NULL;
	printf("\n\n");
	if (NULL == p->ppio) {
		p->ppio = p->fin = temp;
	} else {
		if (strcmp(temp->nombre, p->ppio->nombre)<=0) {
			anadirPpioNodoDado(p, temp);
		} else {
			if (strcmp(temp->nombre, p->fin->nombre)>=0) {
				anadirFinalNodoDado(p, temp);
			} else { // El nodo debe ocupar una posición intermedia
				ant = p->ppio;
				pos = p->ppio->sig;
				while (!(strcmp(ant->nombre,temp->nombre)<=0 && strcmp(temp->nombre,pos->nombre)<=0)) {
					ant = pos;
					pos = pos->sig;
				}
				temp->sig = pos;
				ant->sig = temp;
			}
		}
	}
}

NodoRef eliminarOrdenadoNombre(GlobalRef p){
	NodoRef eliminado = NULL;
	NodoRef indice = NULL;
	printf("\n\nEliminar un nodo (buscando por Nombre)\n\n");
	char * nombreBuscado = pedir("\n\nEscriba el nombre que desea eliminar");
	int estaEnLaLista = 0;
	for(indice=p->ppio;indice != NULL;indice = indice->sig){
		if (strcmp(nombreBuscado, indice->nombre)==0) {
			eliminado = indice;
			estaEnLaLista = 1;
			break;
		}
	}
	if (!estaEnLaLista){
		printf("\n\nEse elemento no está en la lista\n\n");
	}
	else {
		if (p->ppio == eliminado) {
			eliminado = eliminarPrincipio(p);
		} else if (p->fin == eliminado) {
			eliminado = eliminarFinal(p);
		} else {
			for (indice=p->ppio; indice != NULL; indice = indice->sig) {
				if (indice->sig == eliminado) {
					break;
				}
			}
				// indice contiene la dirección del nodo anterior a temp
			indice->sig = eliminado->sig;
		}
	}
	return eliminado;
}

void listado(GlobalRef p){
	NodoRef temp;
	if (NULL == p->ppio)
		printf("\n\nLa lista está vacía.");
	printf("\n\nListado\n\n");
	for (temp=p->ppio; temp!= NULL; temp = temp->sig) {
		escribirPantalla(temp);
	}
	printf("\nFin del Listado.\n\n");
}

void vaciar(GlobalRef p){
	NodoRef temp;
	do {
		temp = eliminarPrincipio(p);
		free(temp);
	} while (NULL != temp);
	printf("\n\nSe ha vaciado la lista.\n\n");
}

void rellenarNodo(NodoRef p){
	strcpy(p->nombre,	pedir("Escriba el nombre   : "));
	p->talla =			pedirFloat("Escriba el peso     : ", 35.0, 120.0);
	p->telefono =		pedirInt(  "Escriba el telefono : ", 923000000, 923999999);
	p->sig = NULL;
}

void escribirPantalla(NodoRef p){
	printf("%20s %10d %6.2f %p\n",
		   p->nombre,
		   p->telefono,
		   p->talla,
		   p->sig);
}